@use 'theme';

$cv-icon-sizes: 24, 32, 64;
$cv-default-icon-size: 16;
$cv-default-icon-color: 'black';

$cv-icon-colors: ('cyan', 'cyanLight'), ('disabled'), ('currentColor');

$cv-colors: (
  'currentColor': currentColor,
  'black': theme.$color-basic-900,
  'cyan': theme.$color-primary-default,
  'cyanLight': theme.$color-primary-hover,
  'disabled': theme.$color-primary-disabled
);

@mixin icon-size($size) {
  width: #{$size}px;
  height: #{$size}px;
}

@mixin icon-color($colorName, $hoverColorName: false) {
  fill: theme.map-get-strict($cv-colors, #{$colorName});

  @if $hoverColorName {
    &:hover {
      fill: theme.map-get-strict($cv-colors, #{$hoverColorName});
      cursor: pointer;
    }
  }
}

:host ::ng-deep {
  .container {
    display: flex;
  }

  svg {
    @include icon-size($cv-default-icon-size);
    @include icon-color($cv-default-icon-color);

    @each $iconSize in $cv-icon-sizes {
      &.size_#{$iconSize} {
        @include icon-size($iconSize);
      }
    }

    @each $color, $hoverColor in $cv-icon-colors {
      @if $hoverColor {
        @include icon-color($color, $hoverColor);
      } @else {
        @include icon-color($color);
      }
    }
  }
}

:host-context(.static) {
  pointer-events: none;
}
